--[[
============================================
LUACave 1.0 by mikehaggar99(at)gmail(dot)com
Partially based on YASFCave
20050829
============================================
]]

dofile("./font.lua")
dofile("./browser.lua")

filen = io.open("high.score","r")

if filen~=nil then
	high=filen:read("*n")
	filen:close()
	if high==nil then
		high=0
	end
else
	high=0
end

width = 480
height = 272
frame = 0
math.randomseed(os.time())
percentage=math.random(0,100)/100
action = Image.createEmpty(480, 272)
wormX=width/3
wormY=(height/2)-1
lastWorm=wormY
speedY=0
accY=0.25
max=2
min=0

borderHeight = 60

tunnelHeight = height - (borderHeight*2)

wormColor = Color.new(255,0,0)
blueColor = Color.new(0,0,255)
backColor = Color.new(16,16,16)
borderColor = Color.new(64,255,0)

SCREENTOPP=1
SCREENBUNN=2
BRICKTOPP=3
BRICKBUNN=4

collision={}
collision[SCREENTOPP] = {}
collision[SCREENBUNN] = {}
collision[BRICKTOPP] = {}
collision[BRICKBUNN] = {}

for i=1,width do
	collision[SCREENTOPP][i] = borderHeight
	collision[SCREENBUNN][i] = borderHeight+tunnelHeight
	collision[BRICKTOPP][i] = 0
	collision[BRICKBUNN][i] = 0
end

action:fillRect(0, 0, width, borderHeight, borderColor)
action:fillRect(0, borderHeight, width, tunnelHeight, backColor)
action:fillRect(0, borderHeight + tunnelHeight, width, borderHeight, borderColor)

function tunnel()
	if math.mod(frame,240)==0 then
		tunnelHeight = tunnelHeight-2
	end

	collision[SCREENTOPP][math.mod(frame,480)] = math.floor(borderHeight)
	collision[SCREENBUNN][math.mod(frame,480)] = math.floor(borderHeight+tunnelHeight)

	action:fillRect(math.mod(frame,480), 0, 1, math.floor(borderHeight), borderColor)
	action:fillRect(math.mod(frame,480), math.floor(borderHeight), 1, tunnelHeight, backColor)
	action:fillRect(math.mod(frame,480), math.floor(borderHeight + tunnelHeight), 1, height - math.floor(borderHeight + tunnelHeight), borderColor)

	if math.mod(frame,120)==0 and tunnelHeight>3 then
		hinder=math.random(math.floor(borderHeight),math.floor(tunnelHeight+borderHeight)-(tunnelHeight/3))
		action:fillRect(math.mod(frame,480), hinder, 1, math.floor(tunnelHeight/3), borderColor)

		collision[BRICKTOPP][math.mod(frame,480)] = hinder
		collision[BRICKBUNN][math.mod(frame,480)] = hinder+math.floor(tunnelHeight/3)
	else
		collision[BRICKTOPP][math.mod(frame,480)] = 0
		collision[BRICKBUNN][math.mod(frame,480)] = 0
	end

	if math.mod(frame,60)==0 then
		if percentage>0 then
			percentage=-(math.random(0,100)*math.floor(height-borderHeight-tunnelHeight)/7000)
		else
			percentage=math.random(0,100)*math.floor(borderHeight)/7000
		end
	end
end

function gameover()
	newscore=0
	if frame>high then
		high=frame
		newscore=1
	end
	showscreen()
	screen.waitVblankStart()
	screen.flip()

	showscreen()
	screen:fillRect(190, 98, 240, 77, blueColor)
	screen:fillRect(195, 103, 230, 67, backColor)
	printEdit(200, 108, "GAME OVER", blueColor, screen, 0, 2)
	screen:print(200, 128, "SCORE: "..frame, blueColor)
	screen:print(200, 138, "HIGH SCORE: "..high, blueColor)
	screen:print(200, 148, "PRESS CIRCLE TO TRY AGAIN", blueColor)
	screen:print(200, 158, "PRESS SELECT TO EXIT", blueColor)
	screen.waitVblankStart()
	screen.flip()

	if newscore==1 then
		filen = io.open("high.score","w")
		filen:write(high)
		filen:flush()
		filen:close()
	end

	frame = 0
	wormX=width/3
	wormY=(height/2)-1
	lastWorm=wormY
	speedY=0
	accY=0.25
	max=2
	borderHeight = 60
	tunnelHeight = height - (borderHeight*2)
	for i=1,width do
		collision[SCREENTOPP][i] = borderHeight
		collision[SCREENBUNN][i] = borderHeight+tunnelHeight
		collision[BRICKTOPP][i] = 0
		collision[BRICKBUNN][i] = 0
	end
	action:fillRect(0, 0, width, borderHeight, borderColor)
	action:fillRect(0, borderHeight, width, tunnelHeight, backColor)
	action:fillRect(0, borderHeight + tunnelHeight, width, borderHeight, borderColor)

	stopped=0
	gostart=false
	if Music.playing() then
		Music.pause()
		stopped=1
	end
	repeat
		pad = Controls.read()
		if pad:circle() then 
			gostart=true
		elseif pad:select() then
			gostart=true
			exit2=true
		elseif pad:triangle() then
			screen:save("screenshot.tga")
		end
	until gostart==true
	screen.waitVblankStart(20)
	if stopped==1 then
		Music.resume()
	end
end

function openmusic()
	if Music.playing() then
		Music.stop()
	end
	fileid,filepath = browser({".mod",".s3m",".xm",".it"},"ms0:/psp/music",1,0,1,0)
	if fileid==false then
	else
		olddir=System.currentDirectory()
		System.currentDirectory(filepath)
		Music.playFile(fileid, true)
		System.currentDirectory(olddir)
	end
end

function showscreen()
	screen:clear()
	screen:blit(0-math.mod(frame,480),0,action)
	screen:blit(480-math.mod(frame,480),0,action)

	if wormY < lastWorm then
		action:fillRect(math.mod(wormX+math.mod(frame,480),480), math.floor(wormY), 1, math.floor(lastWorm-wormY+2), wormColor)
		min=math.floor(wormY)
		max=math.floor(lastWorm+2)
	elseif wormY > lastWorm then
		action:fillRect(math.mod(wormX+math.mod(frame,480),480), math.floor(lastWorm), 1, math.floor(wormY-lastWorm+2), wormColor)
		min=math.floor(lastWorm)
		max=math.floor(wormY+2)
	else
		action:fillRect(math.mod(wormX+math.mod(frame,480),480), math.floor(wormY), 1, 2, wormColor)
		min=math.floor(wormY)
		max=math.floor(wormY+2)
	end
end

function gamepad()
	pad=Controls.read()
	if pad:cross() then
		speedY = speedY-accY
	else
		speedY = speedY+accY
	end

	if pad:hold() then
		stopped=0
		gostart=false
		showscreen()
		printEdit(212, 128, "HOLD", blueColor, screen, 0, 2)
		if Music.playing() then
			Music.pause()
			stopped=1
		end
		screen.waitVblankStart()
		screen.flip()
		repeat
			pad = Controls.read()
			if not pad:hold() then
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(20)
		if stopped==1 then
			Music.resume()
		end
	elseif pad:start() then
		stopped=0
		gostart=false
		showscreen()
		printEdit(204, 128, "PAUSE", blueColor, screen, 0, 2)
		if Music.playing() then
			Music.pause()
			stopped=1
		end
		screen.waitVblankStart()
		screen.flip()
		screen.waitVblankStart(20)
		repeat
			pad = Controls.read()
			if pad:start() then 
				gostart=true
			end
		until gostart==true
		screen.waitVblankStart(20)
		if stopped==1 then
			Music.resume()
		end
	elseif pad:select() then
		exit2=true
	elseif pad:triangle() then
		screen:save("screenshot.tga")
	elseif pad:square() then
		openmusic()
		screen.waitVblankStart(20)
	end
end

function mainmenu()
	screen:clear()
	printEdit(28, 20, "LUACave 1.0", wormColor, screen, 0, 5)
	printEdit(117, 90, "Press X to play!", blueColor, screen, 0, 2)
	printEdit(59, 150, "Circle: About this game", blueColor, screen, 0, 2)
	printEdit(83, 170, "Triangle: Screenshot", blueColor, screen, 0, 2)
	printEdit(75, 190, "Square: Play MOD file", blueColor, screen, 0, 2)
	printEdit(147, 210, "Start: Pause", blueColor, screen, 0, 2)
	printEdit(163, 230, "Hold: Hold", blueColor, screen, 0, 2)
	printEdit(147, 250, "Select: Quit", blueColor, screen, 0, 2)
	screen.waitVblankStart()
	screen.flip()
end

function about()
	screen:clear()
	printEdit(28, 20, "LUACave 1.0", wormColor, screen, 0, 5)
	printEdit(28, 70, "Instructions:", blueColor, screen, 0, 1)
	printEdit(28, 80, "Press X and the worm goes up", blueColor, screen, 0, 1)
	printEdit(28, 90, "Release X and the worm goes down", blueColor, screen, 0, 1)
	printEdit(28, 110, "Programmed by mikehaggar99@hotmail.com", blueColor, screen, 0, 1)
	printEdit(28, 130, "More info on the web", blueColor, screen, 0, 1)
	printEdit(28, 140, "http://haggar.pocketheaven.com/", wormColor, screen, 0, 1)
	printEdit(28, 160, "Partially based on YASFCave that can be found at", blueColor, screen, 0, 1)
	printEdit(28, 170, "http://yasfcave.sourceforge.net/", wormColor, screen, 0, 1)
	printEdit(28, 190, "The original Palm Pilot version can be found at", blueColor, screen, 0, 1)
	printEdit(28, 200, "http://www.sunflat.net/en/", wormColor, screen, 0, 1)
	printEdit(28, 220, "There is also a java online version at", blueColor, screen, 0, 1)
	printEdit(28, 230, "http://www.liquidcode.org/worm.html", wormColor, screen, 0, 1)
	printEdit(28, 250, "This software is released under GNU GPL", blueColor, screen, 0, 1)
	printEdit(28, 260, "Read copying.txt for more info", blueColor, screen, 0, 1)
	screen.waitVblankStart()
	screen.flip()
end

mainmenu()
exit2=false
menus=0
quitting=0

while exit2==false do
	pad = Controls.read()
	if pad:cross() then
		exit2=true
		screen.waitVblankStart(3)
	elseif pad:circle() then
		menus=math.mod(menus+1,2)
		if menus==1 then
			about()
		else
			mainmenu()
		end
		screen.waitVblankStart(3)
	elseif pad:triangle() then
		screen:save("screenshot.tga")
	elseif pad:select() then
		quitting=1
		exit2=true
	elseif pad:square() then
		openmusic()
		if menus==1 then
			about()
		else
			mainmenu()
		end
		screen.waitVblankStart(3)
	end
end

if quitting==0 then
	exit2=false
end

while exit2==false do
	gamepad()

	wormY = wormY+speedY

	showscreen()

	if collision[SCREENTOPP][math.mod(wormX+math.mod(frame,480),480)]>min or collision[SCREENBUNN][math.mod(wormX+math.mod(frame,480),480)]<max or (collision[BRICKTOPP][math.mod(wormX+math.mod(frame,480),480)]-(max-min)<min and collision[BRICKBUNN][math.mod(wormX+math.mod(frame,480),480)]+(max-min)>max) then
		gameover()
	end

	lastWorm=wormY

	screen.waitVblankStart()
	screen.flip()

	tunnel()

	frame=frame+1
	borderHeight=borderHeight-percentage
end

if Music.playing() then
	Music.stop()
end
